#include <sys/types.h>
#include <sys/socket.h>
#include <sys/syslog.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "config.h"

parse(char config_file[255], char s_ias[16], char c_ias[16])
{

FILE *cfp;
char line[MAX_LINE_LEN];
char *cs_ias, *cc_ias, *execstr;

#ifdef DEBUG
printf ("Request from: %s for server %s\n", c_ias, s_ias);
#endif

#ifdef SYSLOG
openlog("mdd", (int)NULL, LOG_DAEMON);
#endif

if ( (cfp=fopen(config_file, "r")) == NULL ) {
#ifdef SYSLOG
	syslog(LOG_INFO, "can't open configuration file %s", config_file);
#else
	perror("can't open configuration file");
#endif
	exit(1);
}

while (fgets(line,MAX_LINE_LEN,cfp)!=NULL) {
	if ((strlen(line)!=1) && (line[0]!='#')) {
		cs_ias=(char *)strtok(line, ":");
		cc_ias=(char *)strtok((char *)0, ":");
		execstr=(char *)strtok((char *)0, ":\n");

		if ( (chk_ias(cs_ias, strdup(s_ias))) && 
		     (chk_ias(cc_ias, strdup(c_ias))) ) {

#ifdef SYSLOG
			syslog(LOG_INFO, "from %s for %s executed %s", c_ias, s_ias, execstr);
#endif
			(void) execl("/bin/sh", "sh", "-c", execstr, (char *) 0);
		}
#ifdef SYSLOG
		else syslog(LOG_INFO, "from %s for %s rejected", c_ias, s_ias);
#endif
	}
};

close(cfp);

}; /* main */

int chk_ias(char *pattern, char *ias)
{

int i;
char *pnr[4],*nr[4];
int go;

	if (strchr(pattern,'*')) return (TRUE);

	go=TRUE;

#ifdef DEBUG
	printf ("pattern: %s request: %s\n",pattern,ias);
#endif

	pnr[0]=(char *)strtok(pattern, ".");
	for (i=1; i<4; i++)
		pnr[i]=(char *)strtok((char *)0, ".");

	nr[0]=(char *)strtok(ias, ".");
	for (i=1; i<4; i++)
		nr[i]=(char *)strtok((char *)0, ".");

	for (i=0; i<4; i++) {
		if (strchr(pnr[i],'-')) go=(go && chk_range(pnr[i],nr[i]));
		else if (atoi(pnr[i])!=atoi(nr[i])) go=FALSE;

	}	

	return (go);

}

int chk_range(char *pnr, char *nr)
{
long numl,numh,num;

	numl=atol((char *)strtok(pnr, "-"));
	numh=atol((char *)strtok((char *)0, "- \n"));
	num=atol(nr);

	if ((num<numl) || (num>numh)) return (FALSE);
	else return(TRUE);

return(FALSE);
}
